// digitalcounterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "digitalcounter.h"
#include "digitalcounterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public cdxCSizingDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : cdxCSizingDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	cdxCSizingDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, cdxCSizingDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDigitalcounterDlg dialog

CDigitalcounterDlg::CDigitalcounterDlg(CWnd* pParent /*=NULL*/)
	: cdxCSizingDialog(CDigitalcounterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDigitalcounterDlg)
	m_dVal = 123.45;
	//}}AFX_DATA_INIT
	m_dNew = m_dVal;
	m_csQuote = _T("A KIND OF MAGIC");
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDigitalcounterDlg::DoDataExchange(CDataExchange* pDX)
{
	cdxCSizingDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDigitalcounterDlg)
	DDX_Control(pDX, IDC_QUOTE_STATIC, m_QuoteText);
	DDX_Control(pDX, IDC_COUNT4, m_Count4);
	DDX_Control(pDX, IDC_COUNT3, m_Count3);
	DDX_Control(pDX, IDC_COUNT2, m_Count2);
	DDX_Control(pDX, IDC_COUNT1, m_Count1);
	DDX_Control(pDX, IDC_TIME_STATIC, m_TimeStatic);
	DDX_Text(pDX, IDC_EDIT1, m_dVal);
	//}}AFX_DATA_MAP
	DDX_DigiDisplay(pDX, IDC_COUNT1, _T("A:%6.2lf"), m_dNew);
	DDX_DigiDisplay(pDX, IDC_COUNT2, _T("B:%6.2lf"), m_dNew);
	DDX_DigiDisplay(pDX, IDC_COUNT3, _T("C:%6.2lf"), m_dNew);
	DDX_DigiDisplay(pDX, IDC_COUNT4, _T("D:%6.2lf"), m_dNew);
	DDX_DigiDisplay(pDX, IDC_QUOTE_STATIC, m_csQuote);

}

BEGIN_MESSAGE_MAP(CDigitalcounterDlg, cdxCSizingDialog)
	//{{AFX_MSG_MAP(CDigitalcounterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDigitalcounterDlg message handlers

BOOL CDigitalcounterDlg::OnInitDialog()
{
	cdxCSizingDialog::OnInitDialog(0);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_Count1.SetBackColor(LIGHTGRAY);
	m_Count1.SetColor(LIGHTGRAY, BLACK);
	m_Count2.SetBackColor(BLACK);
	m_Count2.SetColor(DARKBLUE, LIGHTBLUE);
	m_Count3.SetBackColor(DARKGREEN);
	m_Count3.SetColor(BLACK, YELLOW);
	m_Count4.SetBackColor(BLACK);
	m_Count4.SetColor(BLACK, WHITE);
	m_QuoteText.SetBackColor(BLACK);
	m_QuoteText.SetColor(DARKCYAN, LIGHTCYAN);
	// resizable controls...
	AddSzControl(m_TimeStatic, mdResize, mdResize); 
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDigitalcounterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		cdxCSizingDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDigitalcounterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		cdxCSizingDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDigitalcounterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDigitalcounterDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_dNew = m_dVal;
	UpdateData(FALSE);
}
